package main;

import classmodel.Alle;
import java.lang.reflect.Method;
import java.util.Arrays;
import java.util.List;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.MethodSource;

public class StrukturUndBasisTests {
    private static String[] geforderteKlassen = {"Zugriffsverwaltung", "Nutzung"
            , "Projektadministration", "Systemadministration", "Entwicklung"
    };
    
    private static String[][][] geforderteMethoden ={
        {{"Zugriffsverwaltung"},{"boolean"},{"authentifizieren"},{"String","String"}} 
       ,{{"Zugriffsverwaltung"},{"boolean"},{"entwicklungHinzufuegen"},{"String","String"}}
       ,{{"Zugriffsverwaltung"},{"boolean"},{"loginAendern"},{"String","String"}}  
       ,{{"Zugriffsverwaltung"},{"void"},{"nutzungAnzeigen"},{}}    
       ,{{"Zugriffsverwaltung"},{"boolean"},{"passwortAendern"},{"String","String"}}
       ,{{"Zugriffsverwaltung"},{"boolean"},{"projektadministrationHinzufuegen"},{"String","String"}} 
       ,{{"Zugriffsverwaltung"},{"boolean"},{"systemadministrationHinzufuegen"},{"String","String"}}
       ,{{"Projektadministration"},{"boolean"},{"darfDatenBearbeiten"},{}}  
       ,{{"Projektadministration"},{"boolean"},{"darfTabellenBearbeiten"},{}}
       ,{{"Projektadministration"},{"boolean"},{"darfNutzungAnlegen"},{}}
       ,{{"Systemadministration"},{"boolean"},{"darfDatenBearbeiten"},{}}  
       ,{{"Systemadministration"},{"boolean"},{"darfTabellenBearbeiten"},{}}
       ,{{"Systemadministration"},{"boolean"},{"darfNutzungAnlegen"},{}}
       ,{{"Entwicklung"},{"boolean"},{"darfDatenBearbeiten"},{}}  
       ,{{"Entwicklung"},{"boolean"},{"darfTabellenBearbeiten"},{}}
       ,{{"Entwicklung"},{"boolean"},{"darfNutzungAnlegen"},{}}      
    };
    
    private static String[][][] geforderteKonstruktoren ={
        {{"Zugriffsverwaltung"},{}}
            ,{{"Projektadministration"},{}}
            ,{{"Systemadministration"},{}}
            ,{{"Entwicklung"},{}}
            ,{{"Nutzung"},{}}
            ,{{"Nutzung"},{"String","String"}}
    }; 
    
    private static String[][][] geforderteVariablen = {
        {{"Zugriffsverwaltung"},{"aktuelleNutzung"},{"Nutzung"}, {"private"}}
        , {{"Nutzung"},{"login"},{"String"}, {"private"}}    
        , {{"Nutzung"},{"passwort"},{"String"}, {"private"}}        
    };
     
  	private static Object[][][] geforderteVererbungen = { 
  			{ { "Projektadministration" }, { "Nutzung" } },
  			{ { "Systemadministration" }, { "Nutzung" } }, 
  			{ { "Entwicklung" }, { "Nutzung" } } 
  	};    
    
    private static Object[][][] geforderteErgebnisse ={
       {{"Projektadministration"},{"boolean"},{"darfDatenBearbeiten"},{},{"true"},{}}  
       ,{{"Projektadministration"},{"boolean"},{"darfTabellenBearbeiten"},{},{"true"},{}}
       ,{{"Projektadministration"},{"boolean"},{"darfNutzungAnlegen"},{},{"false"},{}}
       ,{{"Systemadministration"},{"boolean"},{"darfDatenBearbeiten"},{},{"true"},{}}  
       ,{{"Systemadministration"},{"boolean"},{"darfTabellenBearbeiten"},{},{"true"},{}}
       ,{{"Systemadministration"},{"boolean"},{"darfNutzungAnlegen"},{},{"true"},{}}
       ,{{"Entwicklung"},{"boolean"},{"darfDatenBearbeiten"},{},{"true"},{}}  
       ,{{"Entwicklung"},{"boolean"},{"darfTabellenBearbeiten"},{},{"false"},{}}
       ,{{"Entwicklung"},{"boolean"},{"darfNutzungAnlegen"},{},{"false"},{}}      
    };
    
    @ParameterizedTest 
    @MethodSource("klassen")
    public void testKlassenExistieren(String klasse){
      System.out.println(klasse + " " + Alle.findeKlasse(klasse) + " : " + Alle.alleKlassen());
//        for(String klasse: geforderteKlassen){
            Assertions.assertTrue(Alle.findeKlasse(klasse).size() > 0
                , "Klasse " + klasse + " nach Aufgabe gefordert");
//        }
    }
    
    private static String[] klassen(){
        return geforderteKlassen;
    }
      
    @ParameterizedTest 
    @MethodSource("methoden")
    public void testMethodenExistieren(String[][] methode){
//        for(String[][] methode: geforderteMethoden){
            String klasse = methode[0][0];
            String rueckgabetyp = methode[1][0];
            String name = methode[2][0];
            String[] parametertypen = methode[3];
            //System.out.println(klasse + ": " + name +"(" +Arrays.asList(parametertypen) +"): " + rueckgabetyp);
            Assertions.assertTrue(Alle.klasseHatMethodeParametertypenUnbekannt(klasse, rueckgabetyp, name, parametertypen).size() > 0
                , "geforderte Methode " + klasse + ": " + name 
                + "(" +Arrays.asList(parametertypen) +"): " + rueckgabetyp + " nicht gefunden");           
//        }
    }
    
    private static String[][][] methoden(){
        return geforderteMethoden;
    }
    
    @ParameterizedTest 
    @MethodSource("konstruktoren")
//    @TestCaseName("{0}[0], {0}[1]")
    public void testKonstruktorenExistieren(String[][] methode){
//        for(String[][] methode: geforderteKonstruktoren){
            String klasse = methode[0][0];
            String[] parametertypen = methode[1];
            Assertions.assertTrue(Alle.klasseHatKonstruktorParametertypenUnbekannt(klasse, parametertypen).size() > 0
                , "geforderter Konstruktor " + klasse +"(" 
                    +Arrays.asList(parametertypen) + " nicht gefunden");           
//        }
    }  
    
    private static String[][][] konstruktoren(){
        return geforderteKonstruktoren;
    }
    
    @ParameterizedTest 
    @MethodSource("variablen")
    public void testVariablenExistieren(String[][] var){
//        for(String[][] var: geforderteVariablen){
            String klasse = var[0][0];
            String name = var[1][0];
            String typ = var[2][0];
            String[] sichtbar = var[3]; 
            Assertions.assertTrue(Alle.klasseHatVariableVomTypMitSichtbarkeitUndArt(klasse, name, typ, sichtbar)
                , "Geforderte Variable " + name + " in Klasse"
                    + klasse + " mit Typ " + typ + " fehlt");
//        }
    }
    
    private static String[][][] variablen(){
        return geforderteVariablen;
    }
    
    @ParameterizedTest 
    @MethodSource("variablen")
    public void geforderteGetUndSetMethoden(String[][] var){
//         for(String[][] var: geforderteVariablen){
            String klasse = var[0][0];
            String name = var[1][0];
            String typ = var[2][0];
            Assertions.assertTrue(Alle.klasseHatMethodeParametertypenUnbekannt(klasse, typ, "get"+upper(name)).size() > 0
                , "Zur geforderten Variable " + name + " in Klasse"
                    + klasse + " mit Typ " + typ + " fehlt die get-Methode");
            Assertions.assertTrue(Alle.klasseHatMethodeParametertypenUnbekannt(klasse, "void", "set"+upper(name), typ).size() > 0
                , "Zur geforderten Variable " + name + " in Klasse"
                    + klasse + " mit Typ " + typ + " fehlt die set-Methode");            
//        }       
    }
    
    private String upper(String name){
        String tmp = name.toUpperCase();
        return tmp.charAt(0) + name.substring(1);
    }
    
    @ParameterizedTest 
    @MethodSource("vererbungen")
    public void testGeforderteVererbungen(Object[][] erbe){
//        for(String[] erbe: geforderteVererbungen){
            Assertions.assertTrue(Alle.erbtVon(erbe[0][0].toString(), erbe[1][0].toString())
                , "Klasse " + erbe[0] + " sollte von " + erbe[1]
                    + "erben");
//        }
    }
    
    private static Object[][][] vererbungen(){
    //private static List<Object[]> vererbungen(){
        //return Arrays.asList(geforderteVererbungen);
        return geforderteVererbungen;
    }
    
    @Test
    public void testGenutzteSammlung(){
        List<String> typen = Alle.klasseHatVariableMitName("Zugriffsverwaltung", "erlaubteNutzungen");
        boolean gefunden = false;
        for(String typ:typen){
            if (Alle.klasseImplementiertInterface(typ, "java.util.Collection")
                    || Alle.klasseImplementiertInterface(typ, "java.util.Map")
                    || typ.equals("java.util.Map")){
                gefunden = true;
            }
        }
        Assertions.assertTrue(gefunden
            , "Variable erlaubteNutzungen in Zugriffsklasse sollte "
                + "Standard-Collection oder Map nutzen");
    }

    @ParameterizedTest 
    @MethodSource("methodenergebnisse")
    public void testMethodenLiefernErgebnisse(Object[][] methode){
//        for(Object[][] methode: geforderteErgebnisse){
            String klasse = methode[0][0].toString();
            String rueckgabetyp = methode[1][0].toString();
            String name = methode[2][0].toString();
            String[] parametertypen = alsStrings(methode[3]);
            String ergebnis = methode[4][0].toString();
            Object[] aufrufwerte = methode[5]; 
            Method m = Alle.klasseHatMethodeParametertypenUnbekannt(klasse
                           , rueckgabetyp, name, parametertypen)
                      .get(0);
            Assertions.assertTrue(Alle.methodeLiefertErgebnis(ergebnis, m)
                , "Methode " + klasse + ": " + name 
                + "(" +Arrays.asList(parametertypen) +"): " + rueckgabetyp 
                + " liefert mit Parametern " + Arrays.asList(aufrufwerte) 
                +" nicht geforderten Wert " + ergebnis);           
//        }
    }
    
    private static Object[][][] methodenergebnisse(){
        return geforderteErgebnisse;
    }
    
    private String[] alsStrings(Object[] arr){
        String[] ergebnis = new String[arr.length];
        for(int i=0; i < arr.length; i++){
            ergebnis[i] = arr[i].toString();
        }
        return ergebnis;
    }
}